-- This information tells other players more about the mod
name = "Black Rock Shooter 565"
description = "Made by Tirimiru and Bakaduck"
author = "Tirimiru"
version = "2.2.17"

-- This is the URL name of the mod's thread on the forum; the part after the ? and before the first & in the url
forumthread = "http://forums.kleientertainment.com/files/file/1286-black-rock-shooter-dst/"


-- This lets other players know if your mod is out of date, update it to match the current version in the game
api_version = 10

-- Compatible with Don't Starve Together
dst_compatible = true

-- Not compatible with Don't Starve
dont_starve_compatible = false
reign_of_giants_compatible = false

-- Character mods need this set to true
all_clients_require_mod = true 

icon_atlas = "modicon.xml"
icon = "modicon.tex"

-- The mod's tags displayed on the server list
server_filter_tags = {
"character",
}

configuration_options = 
{
	{
	name = "customsounds", 
		label = "Critical sound and animation",
		hover = "Turn ON/OFF critical sound and animation",
		options = 
	{
		{description = "ON [D]", data = "true"},
		{description = "OFF", data = "false"},
	},
		default = "true",
	},

	{
	name = "customequips", 
		label = "Weapon Lock",
		hover = "Blocks other characters from using BRS's weapons.",
		options = 
	{
		{description = "ON [D]", data = "true"},
		{description = "OFF", data = "false"},
	},
		default = "true",
	},

		{
	name = "clothes", 
		label = "Invisible Equipment",
		options = 
	{
		{description = "ON", data = "true"},
		{description = "OFF [D]", data = "false"},
	},
		default = "false",
	},

	{
	name = "blackbladedmg", 
		label = "Black Blade Base Damage",
		hover = "Modify base damage on black blade",
		options = 
	{
		{description = "32 [D]", data = 32},
		{description = "38", data = 38},
		{description = "44", data = 44},
	},
		default = 32,
	},

	{
	name = "bladeclawdmg", 
		label = "Blade Claw Base Damage",
		hover = "Modify base damage on blade claw",
		options = 
	{
		{description = "42 [D]", data = 42},
		{description = "55", data = 55},
		{description = "68", data = 68},
	},
		default = 42,
	},

	{
	name = "maxdura", 
		label = "Durability on Blades",
		hover = "Set finite or infinite durability on Black Blade and Blade Claw",
		options = 
	{
		{description = "Finite [D]", data = "finite"},
		{description = "Infinite", data = "infinite"},
	},
		default = "finite",
	},


	{
	name = "rockcannondmg", 
		label = "Rock Cannon Base Damage",
		hover = "Modify base damage on Rock Cannon",
		options = 
	{
		{description = "30 [D]", data = 30},
		{description = "50", data = 50},
		{description = "80", data = 80},
	},
		default = 30,
	},

	{
	name = "rockcannonaoe", 
		label = "Rock Cannon AoE Damage",
		hover = "Modify AoE damage on Rock Cannon",
		options = 
	{
		{description = "25 [D]", data = 25},
		{description = "50", data = 50},
		{description = "75", data = 75},
	},
		default = 25,
	},

	{
	name = "cannonlancedmg", 
		label = "Cannon Lance Base Damage",
		hover = "Modify base damage on Cannon Lance",
		options = 
	{
		{description = "60 [D]", data = 60},
		{description = "150", data = 150},
		{description = "250", data = 250},
	},
		default = 60,
	},

	{
		name = "workparticledropchance", 
		label = "Workable - Sp. Particle Drop",
		hover = "Drop chance of spirit particles on workable items (e.g. chopping trees)",
		options = 
	{
		{description = "0%", data = 0.00},
		{description = "1%", data = 0.01},
		{description = "2%", data = 0.02},
		{description = "3%", data = 0.03},
		{description = "4%", data = 0.04},
		{description = "5%", data = 0.05},
		{description = "6%", data = 0.06},
		{description = "7%", data = 0.07},
		{description = "8%", data = 0.08},
		{description = "9%", data = 0.09},
		{description = "10% [D]", data = 0.10},
		{description = "11%", data = 0.11},
		{description = "12%", data = 0.12},
		{description = "13%", data = 0.13},
		{description = "14%", data = 0.14},
		{description = "15%", data = 0.15},
		{description = "16%", data = 0.16},
		{description = "17%", data = 0.17},
		{description = "18%", data = 0.18},
		{description = "19%", data = 0.19},
		{description = "20%", data = 0.20},
		{description = "30%", data = 0.30},
		{description = "50%", data = 0.50},
	},
		default = 0.10,
	},

	{
		name = "killparticledropchance", 
		label = "Kills - Sp. Particle Drop",
		hover = "Drop chance of spirit particles upon killing",
		options = 
	{
		{description = "0%", data = 0.00},
		{description = "5%", data = 0.05},
		{description = "10%", data = 0.10},
		{description = "15%", data = 0.15},
		{description = "20%", data = 0.20},
		{description = "25%", data = 0.25},
		{description = "33% [D]", data = 0.33},
		{description = "40%", data = 0.40},
		{description = "50%", data = 0.50},
		{description = "100%", data = 1.00},

	},
		default = 0.33,
	},

	{
	name = "souldropchance", 
		label = "Giant Soul Drop Chance",
		hover = "Drop chance on giant soul upon killing bosses",
		options = 
	{
		{description = "0%", data  = 0.00},
		{description = "50%", data = 0.50},
		{description = "100% [D]", data = 1.00},
	},
		default = 1.00,
	},




}